//======================================================================
// 
//  Regmon.h
//
//  Copyright (C) 1996 Mark Russinovich and Bryce Cogswell
//
//  Typedefs and defines.
// 
//======================================================================

// undocumented ntoskrnl variable
extern PSHORT           NtBuildNumber;

// undocumented pointer to the system service table
extern PULONG KeServiceDescriptorTable;

// basic types
typedef unsigned int    UINT;
typedef char            CHAR;
typedef char *          PCHAR;
typedef PVOID           POBJECT;


// these are the registry calls we hook
enum {
	REGOPENKEY,
	REGQUERYKEY,
	REGQUERYVALUEKEY,
	REGENUMERATEKEY,
	REGENUMERATEVALUEKEY,
	REGFLUSHKEY,
	REGDELETEKEY,
	REGSETVALUEKEY,
	REGCREATEKEY,
	REGDELETEVALUEKEY,
	REGCLOSEKEY
};


// these are undocumented and I haven't seen them called
#define REGRESTOREKEY                   0x94
#define REGSAVEKEY                      0x96
#define REGREPLACEKEY                   0x8D
#define REGQUERYMULTIPLEVALUEKEY        0x72

// queryobject parameters (we only use  QUERYOBJTYPE)
#define QUERYOBJINFO                    0
#define QUERYOBJNAME                    1
#define QUERYOBJTYPE                    2
#define QUERYOBJALL                     3
#define QUERYOBJDATA                    4


// structure pass by queryobject 
typedef struct _OBQUERYTYPE {
	UNICODE_STRING          Name;
	UNICODE_STRING          Type;
	UINT                    TotalHandles;
	UINT                    ReferenceCount;
} OBQUERYTYPE, * POBQUERYTYPE;  

// definition for system call service table
typedef struct _SRVTABLE {
	PVOID           *ServiceTable;
	ULONG           LowCall;        
	ULONG           HiCall;
	PVOID		*ArgTable;
} SRVTABLE, *PSRVTABLE;

// Structure for our name hash table
typedef struct _nameentry {
   POBJECT              Object;
   PCHAR                FullPathName;
   struct _nameentry    *Next;
} HASH_ENTRY, *PHASH_ENTRY;

// Structure for keeping linked lists of output buffers
typedef struct _store {
    ULONG               Len;
    struct _store *     Next;
    char                Data[ MAX_STORE ];
} STORE_BUF, *PSTORE_BUF;

// rootkey name translation structure
typedef struct _rootkey {
    CHAR                RootName[256];
    CHAR                RootShort[32];
    ULONG               RootNameLen;
} ROOTKEY, *PROOTKEY;

// number of hash buckets
#define NUMHASH         0x100
#define HASHOBJECT(_regobject)          (((ULONG)_regobject)>>2)%NUMHASH


// definition for undocumented query object call
NTSYSAPI
NTSTATUS 
NTAPI 
ZwQueryObject( PHANDLE Handle, ULONG QueryType,  POBQUERYTYPE objtype, ULONG Len, 
		PULONG RetLen );

// internal data structure offsets - there is *no* clean way to get a process' name
// without doing a full systeminformation query on each call (which would obtain info
// on every process and thread in the system!)
// These offsets are valid for NT 3.51 and NT 4.0 (lucky for us!)
#define NAMEOFFSET		0x1DC





